<?php

class felix_reaction_block extends context_reaction_block {
  function block_list($region) {
    $blocks = parent::block_list($region);
    
    $felix_regions = _felix_regions_by_context($region);
    foreach ($felix_regions as $felix_region) {
      if (user_access('manage felix blocks')) {
        $block = new stdClass;
        $block->module = 'felix';
        $block->delta = 'add-block';
        $block->status = 1;
        $block->weight = $felix_region->weight;
        $block->weight_felix = 0;
        $block->region = $region;
        $block->subject = $felix_region->title;
        $block->content = array(
          '#markup' => l(t('Add block'), 'felix-blocks/add', array(
            'query' => array(
              'region' => $felix_region->name,
              'path' => $_GET['q'],
            ),
          )),
        );
        $blocks[] = $block;
      }
      
      $region_blocks = _felix_get_blocks_by_region($felix_region);
      $item_number = 0;
      foreach ($region_blocks as $block) {
        ++$item_number;
        $block->status = 1;
        $block->weight = $felix_region->weight;
        $block->weight_felix = $item_number;
        $block->region = $region;
        
        // Add the block controls if we may manage this region.
        if (user_access('manage felix blocks')) {
          $block->content = array(
            'content' => $block->content,
            'felix' => array(
              '#markup' => _felix_render_block_controls($felix_region, $block, $item_number, count($region_blocks)),
            ),
          );
        }
        
        $blocks[] = $block;
      }
    }
    
    // Sort blocks by weight and weight_felix.
    uasort($blocks, 'felix_sort_blocks');
    
    return $blocks;
  }
}
